/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC16F18424
        Driver Version    :  2.00
 
  SMT clock: 1MHz (Period:1us) 


*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"
#include <stdio.h>
#include "lcd_lib2.h"
#include "i2c_lib2.h"

// O[oϐ錾
unsigned long CPR,Rev;      // SMTLv`l,]i[pϐ

// Wo͊֐p჌x֐`
void putch(unsigned char data) {
    lcd_data(data);                 // t\Wo͊֐Ƃ    
}

/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();      // O[o

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();      // ӊ

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    // foCX    
    lcd_init();     // LCD      
    
    // ϐ    
    CPR = 0;
    Rev = 0;    

    // LCD\
    lcd_cmd(0x80);      // LCD1s
        printf("SMT Tachometer");     // bZ[W
    lcd_cmd(0xC0);      // LCD2s
        printf("Start !");     // bZ[W        
        
    while (1)
    {
        // Add your application code
        
        SMT1_ManualTimerReset();    // SMTxTMRZbg               

        PIR8bits.SMT1PWAIF = 0;     // 荞݃tOPWAIFNA 
        PIR8bits.SMT1PRAIF = 0;     // 荞݃tOPRAIFNA         

        SMT1CON1bits.SMT1GO = 1;    // SMTvJn 
        while (SMT1CON1bits.SMT1GO == 1)    // vI҂

        CPR = SMT1_GetCapturedPeriod();     // Lv`l擾

        // LCDo
            Rev = 1000000 * 60 / CPR;     // SMTxWINM(us)](rpm)ɊZ   
            lcd_cmd(0xC0);      // LCD2s
            printf("%5lu rpm",Rev);     // ](rpm)\ 

        __delay_ms(200);    // 0.2 sec                  
    }
}
/**
 End of File
*/